#include "vulkan_util.hpp"
#include <vulkan/vulkan_core.h>


namespace gz::vk {
	void PipelineContainer::erase(const PipelineT& key, VkDevice& device, const VkAllocationCallbacks* pAllocator) {
        vkDestroyPipeline(device, pipelines[key].pipeline, pAllocator);
        vkDestroyPipelineLayout(device, pipelines[key].layout, pAllocator);
		pipelines.erase(pipelines.find(key));
	}
	PipelineContainer::iterator PipelineContainer::erase(const PipelineContainer::iterator& it, VkDevice& device, const VkAllocationCallbacks* pAllocator) {
        vkDestroyPipeline(device, it->second.pipeline, pAllocator);
        vkDestroyPipelineLayout(device, it->second.layout, pAllocator);
		return pipelines.erase(it);
		
	}

} // namespace gz::vk



